"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.readModel = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _lodash = _interopRequireDefault(require("lodash.partial"));

var _query = require("./query");

var _withAdapter = require("./with-adapter");

var _withEncryption = require("./with-encryption");

// FIXME: deprecated
var makeDeprecatedResolverMap = function makeDeprecatedResolverMap(readModel, bindResolver) {
  return Object.keys(readModel.resolvers).reduce(function (map, name) {
    map[name] = function (args) {
      // eslint-disable-next-line no-console
      console.warn("Direct resolver selector deprecated, you should use 'query' selector with arguments instead.");
      return bindResolver(name, args);
    };

    return map;
  }, {});
};

var readModel = function readModel(givenEventsContext, _readModel) {
  var context = (0, _extends2["default"])({}, givenEventsContext, {
    readModel: _readModel
  }); // FIXME: deprecated

  if (_readModel.adapter != null) {
    // eslint-disable-next-line no-console
    console.warn("'adapter' property of read model deprecated, use 'withAdapter' selector instead.");
    (0, _withAdapter.withAdapter)(context, _readModel.adapter);
  } // FIXME: deprecated


  if (_readModel.encryption != null) {
    // eslint-disable-next-line no-console
    console.warn("'encryption' property of read model deprecated, use 'withEncryption' selector instead.");
    (0, _withEncryption.withEncryption)(context, _readModel.encryption);
  }

  return (0, _extends2["default"])({
    query: (0, _lodash["default"])(_query.query, context),
    withAdapter: (0, _lodash["default"])(_withAdapter.withAdapter, context),
    withEncryption: (0, _lodash["default"])(_withEncryption.withEncryption, context),
    then: function then() {
      throw Error("Incomplete BDD test configuration! Please, provide a query.");
    }
  }, makeDeprecatedResolverMap(_readModel, (0, _lodash["default"])(_query.query, context)));
};

exports.readModel = readModel;
//# sourceMappingURL=read-model.js.map